# HG changeset patch
# User Barbara Lócsi <locsi.barbara@gmail.com>
# Date 1467407083 -7200
#      Fri Jul 01 23:04:43 2016 +0200
# Node ID 1e6628b3dc0ea6a75f1e245ebdeaa56f2082306b
# Parent  cc55436c4cbc3db2e42e6e70f83051d91417cc9e
add chol/qz flag to eig

diff -r cc55436c4cbc -r 1e6628b3dc0e libinterp/corefcn/eig.cc
--- a/libinterp/corefcn/eig.cc	Fri Jul 01 22:04:34 2016 +0200
+++ b/libinterp/corefcn/eig.cc	Fri Jul 01 23:04:43 2016 +0200
@@ -52,7 +52,7 @@ The eigenvalues returned by @code{eig} a
 {
   int nargin = args.length ();
 
-  if (nargin > 2 || nargin == 0)
+  if (nargin > 3 || nargin == 0)
     print_usage ();
 
   octave_value_list retval;
@@ -75,42 +75,60 @@ The eigenvalues returned by @code{eig} a
   if (! arg_a.is_double_type () && ! arg_a.is_single_type ())
     err_wrong_type_arg ("eig", arg_a);
 
+  if (nr_a != nc_a)
+    err_square_matrix_required ("eig", "A");
+  
   bool balance = true;
-  if (nargin == 2)
+  bool force_qz = false;
+  
+  // determine if it's AEP or GEP
+  bool AEPcase = nargin == 1 || args(1).is_string ();
+  
+  if (AEPcase)
     {
-      if(args(1).is_string ())
+      if (nargin == 2)
         {
           std::string a1s = args(1).string_value ();
           if(a1s != "balance" && a1s != "nobalance")
             error ("eig: unexpected second input: %s", a1s.c_str ());
           balance = a1s == "balance";
         }
-      else
+      if (nargin == 3)
         {
-          arg_b = args(1);
-          nr_b = arg_b.rows ();
-          nc_b = arg_b.columns ();
-
-          arg_is_empty = empty_arg ("eig", nr_b, nc_b);
-          if (arg_is_empty < 0)
-            return retval;
-          else if (arg_is_empty > 0)
-            return ovl (2, Matrix ());
-
-          if (! arg_b.is_single_type () && ! arg_b.is_double_type ())
-            err_wrong_type_arg ("eig", arg_b);
+          if(!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          std::string a2s = args(2).string_value ();
+            error ("eig: unexpected third input: %s", a2s.c_str ());
         }
     }
+  else
+    {
+      arg_b = args(1);
+      nr_b = arg_b.rows ();
+      nc_b = arg_b.columns ();
 
-  if (nr_a != nc_a)
-    err_square_matrix_required ("eig", "A");
-  
-  // determine if it's AEP or GEP
-  bool AEPcase = nargin == 1 || args(1).is_string ();
-  
+      arg_is_empty = empty_arg ("eig", nr_b, nc_b);
+      if (arg_is_empty < 0)
+        return retval;
+      else if (arg_is_empty > 0)
+        return ovl (2, Matrix ());
+
+      if (! arg_b.is_single_type () && ! arg_b.is_double_type ())
+        err_wrong_type_arg ("eig", arg_b);
+      if(nargin == 3)
+        {
+          if(!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          std::string a2s = args(2).string_value ();
+          if(a2s != "chol" && a2s != "qz")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          force_qz = a2s == "qz";
+        }
+    }
+    
   if (!AEPcase && nr_b != nc_b)
     err_square_matrix_required ("eig", "B");
-
+  
   Matrix tmp_a, tmp_b;
   ComplexMatrix ctmp_a, ctmp_b;
   FloatMatrix ftmp_a, ftmp_b;
@@ -141,14 +159,14 @@ The eigenvalues returned by @code{eig} a
               ftmp_a = arg_a.float_matrix_value ();
               ftmp_b = arg_b.float_matrix_value ();
 
-              result = FloatEIG (ftmp_a, ftmp_b, nargout > 1, nargout > 2);
+              result = FloatEIG (ftmp_a, ftmp_b, nargout > 1, nargout > 2, force_qz);
             }
           else
             {
               fctmp_a = arg_a.float_complex_matrix_value ();
               fctmp_b = arg_b.float_complex_matrix_value ();
 
-              result = FloatEIG (fctmp_a, fctmp_b, nargout > 1, nargout > 2);
+              result = FloatEIG (fctmp_a, fctmp_b, nargout > 1, nargout > 2, force_qz);
             }
         }
 
@@ -196,14 +214,14 @@ The eigenvalues returned by @code{eig} a
               tmp_a = arg_a.matrix_value ();
               tmp_b = arg_b.matrix_value ();
 
-              result = EIG (tmp_a, tmp_b, nargout > 1, nargout > 2);
+              result = EIG (tmp_a, tmp_b, nargout > 1, nargout > 2, force_qz);
             }
           else
             {
               ctmp_a = arg_a.complex_matrix_value ();
               ctmp_b = arg_b.complex_matrix_value ();
 
-              result = EIG (ctmp_a, ctmp_b, nargout > 1, nargout > 2);
+              result = EIG (ctmp_a, ctmp_b, nargout > 1, nargout > 2, force_qz);
             }
         }
 
@@ -240,11 +258,21 @@ The eigenvalues returned by @code{eig} a
 %! assert (v, [-x, x; x, x], sqrt (eps));
 
 %!test
+%! [v, d, w] = eig ([1, 2; 2, 1]);
+%! x = 1 / sqrt (2);
+%! assert (w, [-x, x; x, x], sqrt (eps));
+
+%!test
 %! [v, d] = eig ([1, 2; 2, 1], 'balance');
 %! x = 1 / sqrt (2);
 %! assert (d, [-1, 0; 0, 3], sqrt (eps));
 %! assert (v, [-x, x; x, x], sqrt (eps));
 
+%!test
+%! [v, d, w] = eig ([1, 2; 2, 1], 'balance');
+%! x = 1 / sqrt (2);
+%! assert (w, [-x, x; x, x], sqrt (eps));
+
 %!assert (eig (single ([1, 2; 2, 1])), single ([-1; 3]), sqrt (eps ("single")))
 
 %!assert (eig (single ([1, 2; 2, 1]), 'balance'), single ([-1; 3]), sqrt (eps ("single")))
@@ -256,84 +284,276 @@ The eigenvalues returned by @code{eig} a
 %! assert (v, [-x, x; x, x], sqrt (eps ("single")));
 
 %!test
+%! [v, d, w] = eig (single ([1, 2; 2, 1]));
+%! x = single (1 / sqrt (2));
+%! assert (w, [-x, x; x, x], sqrt (eps ("single")));
+
+%!test
 %! [v, d] = eig (single ([1, 2; 2, 1]), 'balance');
 %! x = single (1 / sqrt (2));
 %! assert (d, single ([-1, 0; 0, 3]), sqrt (eps ("single")));
 %! assert (v, [-x, x; x, x], sqrt (eps ("single")));
 
 %!test
+%! [v, d, w] = eig (single ([1, 2; 2, 1]), 'balance');
+%! x = single (1 / sqrt (2));
+%! assert (w, [-x, x; x, x], sqrt (eps ("single")));
+
+%!test
 %! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'qz');
+%! [v3, d3] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'qz');
+%! [v3, d3, w3] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+%! assert (w, w2);
+%! assert (w, w3);
 
 %!test
 %! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'qz');
+%! [v3, d3] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'qz');
+%! [v3, d3, w3] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+%! assert (w, w2);
+%! assert (w, w3);
 
 %!test
 %! A = [1, 2; 2, 1];  B = [3, -2; -2, 3];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = [1, 2; 2, 1];  B = [3, -2; -2, 3];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = single ([1, 2; 2, 1]);  B = single ([3, -2; -2, 3]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);  B = single ([3, -2; -2, 3]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = [1+3i, 2+3i; 3-8i, 8+3i];  B = [8+i, 3+i; 4-9i, 3+i];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'qz');
+%! [v3, d3] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (v, v3);
+%! assert (d, d3);
+
+%!test
+%! A = [1+3i, 2+3i; 3-8i, 8+3i];  B = [8+i, 3+i; 4-9i, 3+i];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'qz');
+%! [v3, d3, w3] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+%! assert (v, v3);
+%! assert (d, d3);
+%! assert (w, w3);
 
 %!test
 %! A = single ([1+3i, 2+3i; 3-8i, 8+3i]);  B = single ([8+i, 3+i; 4-9i, 3+i]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'qz');
+%! [v3, d3] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (v, v3);
+%! assert (d, d3);
+
+%!test
+%! A = single ([1+3i, 2+3i; 3-8i, 8+3i]);  B = single ([8+i, 3+i; 4-9i, 3+i]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'qz');
+%! [v3, d3, w3] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+%! assert (v, v3);
+%! assert (d, d3);
+%! assert (w, w3);
 
 %!test
 %! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'qz');
+%! [v3, d3] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (v, v3);
+%! assert (d, d3);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'qz');
+%! [v3, d3, w3] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+%! assert (v, v3);
+%! assert (d, d3);
+%! assert (w, w3);
 
 %!test
 %! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = single ([1, 1+i; 1-i, 1]);  B = single ([2, 0; 0, 2]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, 'chol');
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
 
-%!error eig ()
-%!error eig ([1, 2; 3, 4], [4, 3; 2, 1], 1)
-%!error <EIG requires same size matrices> eig ([1, 2; 3, 4], 2)
-%!error <must be a square matrix> eig ([1, 2; 3, 4; 5, 6])
-%!error <wrong type argument> eig ("abcd")
-%!error <eig: unexpected second input: abcd> eig ([1 2 ; 2 3], "abcd")
-%!error <wrong type argument> eig (false, [1 2 ; 2 3])
+%!test
+%! A = single ([1, 1+i; 1-i, 1]);  B = single ([2, 0; 0, 2]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, 'chol');
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
 %!test
 %! A = [3 -2 -0.9 0; -2 4 1 -0; -0 0 -1 0; -0.5 -0.5 0.1 1];
 %! [V1, D1] = eig (A);
@@ -342,4 +562,29 @@ The eigenvalues returned by @code{eig} a
 %! assert (V1, V2);
 %! assert (D1, D2);
 %! assert (isequal (V2, V3), false);
+
+%!test
+%! A = diag([10^-16, 10^-15]);
+%! [V1,D1] = eig(A,A);
+%! [V2,D2] = eig(A,A,'qz');
+%! [V3,D3] = eig(A,A,'chol');
+%! assert (V1, V3);
+%! assert (D1, D3);
+%! assert (isequal (V1, V2), false);
+
+%!error eig ()
+%!error eig (false)
+%!error eig ([1, 2; 3, 4], [4, 3; 2, 1], 1)
+%!error <EIG requires same size matrices> eig ([1, 2; 3, 4], 2)
+%!error <must be a square matrix> eig ([1, 2; 3, 4; 5, 6])
+%!error <wrong type argument> eig ("abcd")
+%!error <eig: unexpected second input: abcd> eig ([1 2 ; 2 3], "abcd")
+%!error <eig: unexpected second input: chol> eig ([1 2 ; 2 3], "chol")
+%!error <eig: unexpected second input: qz> eig ([1 2 ; 2 3], "qz")
+%!error <wrong type argument> eig (false, [1 2 ; 2 3])
+%!error <eig: unexpected third input: abcd> eig ([1 2 ; 2 3], [1 2 ; 2 3], "abcd")
+%!error <eig: unexpected third input: qz> eig ([1 2 ; 2 3], 'balance', 'qz')
+%!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], false)
+%!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], [1 2 ; 2 3])
+
 */
\ No newline at end of file
diff -r cc55436c4cbc -r 1e6628b3dc0e liboctave/numeric/EIG.cc
--- a/liboctave/numeric/EIG.cc	Fri Jul 01 22:04:34 2016 +0200
+++ b/liboctave/numeric/EIG.cc	Fri Jul 01 23:04:43 2016 +0200
@@ -494,7 +494,7 @@ EIG::hermitian_init (const ComplexMatrix
 }
 
 octave_idx_type
-EIG::init (const Matrix& a, const Matrix& b, bool calc_rev, bool calc_lev)
+EIG::init (const Matrix& a, const Matrix& b, bool calc_rev, bool calc_lev, bool force_qz)
 {
   if (a.any_element_is_inf_or_nan () || b.any_element_is_inf_or_nan ())
     (*current_liboctave_error_handler)
@@ -513,14 +513,17 @@ EIG::init (const Matrix& a, const Matrix
 
   Matrix tmp = b;
   double *tmp_data = tmp.fortran_vec ();
-
-  F77_XFCN (dpotrf, DPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
-                             n, tmp_data, n,
-                             info
-                             F77_CHAR_ARG_LEN (1)));
-
-  if (a.is_symmetric () && b.is_symmetric () && info == 0)
-    return symmetric_init (a, b, calc_rev, calc_lev);
+  
+  if(!force_qz)
+    {
+      F77_XFCN (dpotrf, DPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
+                                 n, tmp_data, n,
+                                 info
+                                 F77_CHAR_ARG_LEN (1)));
+                                 
+      if (a.is_symmetric () && b.is_symmetric () && info == 0)
+        return symmetric_init (a, b, calc_rev, calc_lev);
+    }
 
   Matrix atmp = a;
   double *atmp_data = atmp.fortran_vec ();
@@ -548,7 +551,7 @@ EIG::init (const Matrix& a, const Matrix
   octave_idx_type lwork = -1;
   double dummy_work;
 
-  F77_XFCN (dggev, DGGEV, (F77_CONST_CHAR_ARG2 ("N", 1),
+  F77_XFCN (dggev, DGGEV, (F77_CONST_CHAR_ARG2 (calc_lev ? "V" : "N", 1),
                            F77_CONST_CHAR_ARG2 (calc_rev ? "V" : "N", 1),
                            n, atmp_data, n, btmp_data, n,
                            par, pai, pbeta,
@@ -564,7 +567,7 @@ EIG::init (const Matrix& a, const Matrix
   Array<double> work (dim_vector (lwork, 1));
   double *pwork = work.fortran_vec ();
 
-  F77_XFCN (dggev, DGGEV, (F77_CONST_CHAR_ARG2 ("N", 1),
+  F77_XFCN (dggev, DGGEV, (F77_CONST_CHAR_ARG2 (calc_lev ? "V" : "N", 1),
                            F77_CONST_CHAR_ARG2 (calc_rev ? "V" : "N", 1),
                            n, atmp_data, n, btmp_data, n,
                            par, pai, pbeta,
@@ -690,7 +693,7 @@ EIG::symmetric_init (const Matrix& a, co
 }
 
 octave_idx_type
-EIG::init (const ComplexMatrix& a, const ComplexMatrix& b, bool calc_rev, bool calc_lev)
+EIG::init (const ComplexMatrix& a, const ComplexMatrix& b, bool calc_rev, bool calc_lev, bool force_qz)
 {
   if (a.any_element_is_inf_or_nan () || b.any_element_is_inf_or_nan ())
     (*current_liboctave_error_handler)
@@ -709,14 +712,17 @@ EIG::init (const ComplexMatrix& a, const
 
   ComplexMatrix tmp = b;
   Complex*tmp_data = tmp.fortran_vec ();
+  
+  if(!force_qz)
+    {
+      F77_XFCN (zpotrf, ZPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
+                                 n, tmp_data, n,
+                                 info
+                                 F77_CHAR_ARG_LEN (1)));
 
-  F77_XFCN (zpotrf, ZPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
-                             n, tmp_data, n,
-                             info
-                             F77_CHAR_ARG_LEN (1)));
-
-  if (a.is_hermitian () && b.is_hermitian () && info == 0)
-    return hermitian_init (a, b, calc_rev, calc_lev);
+      if (a.is_hermitian () && b.is_hermitian () && info == 0)
+        return hermitian_init (a, b, calc_rev, calc_lev);
+    }
 
   ComplexMatrix atmp = a;
   Complex *atmp_data = atmp.fortran_vec ();
diff -r cc55436c4cbc -r 1e6628b3dc0e liboctave/numeric/EIG.h
--- a/liboctave/numeric/EIG.h	Fri Jul 01 22:04:34 2016 +0200
+++ b/liboctave/numeric/EIG.h	Fri Jul 01 23:04:43 2016 +0200
@@ -40,62 +40,62 @@ EIG
 
 public:
 
-  EIG (void) : lambda (), v () { }
+  EIG (void) : lambda (), v (), w () { }
 
   EIG (const Matrix& a, bool calc_rev = true,
        bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     init (a, calc_rev, calc_lev, balance);
   }
 
   EIG (const Matrix& a, octave_idx_type& info,
        bool calc_rev = true, bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     info = init (a, calc_rev, calc_lev, balance);
   }
 
   EIG (const Matrix& a, const Matrix& b,
-       bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+       bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    init (a, b, calc_rev, calc_lev);
+    init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   EIG (const Matrix& a, const Matrix& b, octave_idx_type& info,
-       bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+       bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    info = init (a, b, calc_rev, calc_lev);
+    info = init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   EIG (const ComplexMatrix& a, bool calc_rev = true,
        bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     init (a, calc_rev, calc_lev, balance);
   }
 
   EIG (const ComplexMatrix& a, octave_idx_type& info,
        bool calc_rev = true, bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     info = init (a, calc_rev, calc_lev, balance);
   }
 
   EIG (const ComplexMatrix& a, const ComplexMatrix& b,
-       bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+       bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    init (a, b, calc_rev, calc_lev);
+    init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   EIG (const ComplexMatrix& a, const ComplexMatrix& b,
-       octave_idx_type& info, bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+       octave_idx_type& info, bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    info = init (a, b, calc_rev, calc_lev);
+    info = init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   EIG (const EIG& a) : lambda (a.lambda), v (a.v), w (a.w) { }
@@ -129,13 +129,13 @@ private:
                         bool balance);
 
   octave_idx_type init (const Matrix& a, const Matrix& b,
-                        bool calc_rev, bool calc_lev);
+                        bool calc_rev, bool calc_lev, bool force_qz);
 
   octave_idx_type init (const ComplexMatrix& a, bool calc_rev,
                         bool calc_lev, bool balance);
 
   octave_idx_type init (const ComplexMatrix& a, const ComplexMatrix& b,
-                        bool calc_rev, bool calc_lev);
+                        bool calc_rev, bool calc_lev, bool force_qz);
 
   octave_idx_type symmetric_init (const Matrix& a, bool calc_rev, bool calc_lev);
 
diff -r cc55436c4cbc -r 1e6628b3dc0e liboctave/numeric/fEIG.cc
--- a/liboctave/numeric/fEIG.cc	Fri Jul 01 22:04:34 2016 +0200
+++ b/liboctave/numeric/fEIG.cc	Fri Jul 01 23:04:43 2016 +0200
@@ -483,7 +483,7 @@ FloatEIG::hermitian_init (const FloatCom
 }
 
 octave_idx_type
-FloatEIG::init (const FloatMatrix& a, const FloatMatrix& b, bool calc_rev, bool calc_lev)
+FloatEIG::init (const FloatMatrix& a, const FloatMatrix& b, bool calc_rev, bool calc_lev, bool force_qz)
 {
   if (a.any_element_is_inf_or_nan () || b.any_element_is_inf_or_nan ())
     (*current_liboctave_error_handler)
@@ -502,14 +502,16 @@ FloatEIG::init (const FloatMatrix& a, co
 
   FloatMatrix tmp = b;
   float *tmp_data = tmp.fortran_vec ();
+  if(!force_qz)
+    {
+      F77_XFCN (spotrf, SPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
+                                 n, tmp_data, n,
+                                 info
+                                 F77_CHAR_ARG_LEN (1)));
 
-  F77_XFCN (spotrf, SPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
-                             n, tmp_data, n,
-                             info
-                             F77_CHAR_ARG_LEN (1)));
-
-  if (a.is_symmetric () && b.is_symmetric () && info == 0)
-    return symmetric_init (a, b, calc_rev, calc_lev);
+      if (a.is_symmetric () && b.is_symmetric () && info == 0)
+        return symmetric_init (a, b, calc_rev, calc_lev);
+    }
 
   FloatMatrix atmp = a;
   float *atmp_data = atmp.fortran_vec ();
@@ -680,7 +682,7 @@ FloatEIG::symmetric_init (const FloatMat
 
 octave_idx_type
 FloatEIG::init (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
-                bool calc_rev, bool calc_lev)
+                bool calc_rev, bool calc_lev, bool force_qz)
 {
   if (a.any_element_is_inf_or_nan () || b.any_element_is_inf_or_nan ())
     (*current_liboctave_error_handler)
@@ -700,13 +702,16 @@ FloatEIG::init (const FloatComplexMatrix
   FloatComplexMatrix tmp = b;
   FloatComplex *tmp_data = tmp.fortran_vec ();
 
-  F77_XFCN (cpotrf, CPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
-                             n, tmp_data, n,
-                             info
-                             F77_CHAR_ARG_LEN (1)));
+  if(!force_qz)
+    {
+      F77_XFCN (cpotrf, CPOTRF, (F77_CONST_CHAR_ARG2 ("L", 1),
+                                 n, tmp_data, n,
+                                 info
+                                 F77_CHAR_ARG_LEN (1)));
 
-  if (a.is_hermitian () && b.is_hermitian () && info == 0)
-    return hermitian_init (a, b, calc_rev, calc_lev);
+      if (a.is_hermitian () && b.is_hermitian () && info == 0)
+        return hermitian_init (a, b, calc_rev, calc_lev);
+    }
 
   FloatComplexMatrix atmp = a;
   FloatComplex *atmp_data = atmp.fortran_vec ();
diff -r cc55436c4cbc -r 1e6628b3dc0e liboctave/numeric/fEIG.h
--- a/liboctave/numeric/fEIG.h	Fri Jul 01 22:04:34 2016 +0200
+++ b/liboctave/numeric/fEIG.h	Fri Jul 01 23:04:43 2016 +0200
@@ -40,62 +40,62 @@ FloatEIG
 
 public:
 
-  FloatEIG (void) : lambda (), v () { }
+  FloatEIG (void) : lambda (), v (), w () { }
 
   FloatEIG (const FloatMatrix& a, bool calc_rev = true,
             bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     init (a, calc_rev, calc_lev, balance);
   }
 
   FloatEIG (const FloatMatrix& a, octave_idx_type& info,
             bool calc_rev = true, bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     info = init (a, calc_rev, calc_lev, balance);
   }
 
   FloatEIG (const FloatMatrix& a, const FloatMatrix& b,
-            bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+            bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    init (a, b, calc_rev, calc_lev);
+    init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   FloatEIG (const FloatMatrix& a, const FloatMatrix& b, octave_idx_type& info,
-            bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+            bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    info = init (a, b, calc_rev, calc_lev);
+    info = init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   FloatEIG (const FloatComplexMatrix& a, bool calc_rev = true,
             bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     init (a, calc_rev, calc_lev, balance);
   }
 
   FloatEIG (const FloatComplexMatrix& a, octave_idx_type& info,
             bool calc_rev = true, bool calc_lev = true, bool balance = true)
-    : lambda (), v ()
+    : lambda (), v (), w ()
   {
     info = init (a, calc_rev, calc_lev, balance);
   }
 
   FloatEIG (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
-            bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+            bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    init (a, b, calc_rev, calc_lev);
+    init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   FloatEIG (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
-            octave_idx_type& info, bool calc_rev = true, bool calc_lev = true)
-    : lambda (), v ()
+            octave_idx_type& info, bool calc_rev = true, bool calc_lev = true, bool force_qz = false)
+    : lambda (), v (), w ()
   {
-    info = init (a, b, calc_rev, calc_lev);
+    info = init (a, b, calc_rev, calc_lev, force_qz);
   }
 
   FloatEIG (const FloatEIG& a) : lambda (a.lambda), v (a.v), w (a.w) { }
@@ -129,13 +129,13 @@ private:
                         bool balance);
                         
   octave_idx_type init (const FloatMatrix& a, const FloatMatrix& b,
-                        bool calc_rev, bool calc_lev);
+                        bool calc_rev, bool calc_lev, bool force_qz);
                         
   octave_idx_type init (const FloatComplexMatrix& a, bool calc_rev,
                         bool calc_lev, bool balance);
                         
   octave_idx_type init (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
-                        bool calc_rev, bool calc_lev);
+                        bool calc_rev, bool calc_lev, bool force_qz);
 
   octave_idx_type symmetric_init (const FloatMatrix& a, bool calc_rev, bool calc_lev);
   
